commit d3c268943c339e994802656ce71ef654cc2a349f
Author: Iain Buclaw <ibuclaw@gdcproject.org>
Date:   Tue Jul 27 13:24:34 2021

    d: Wrong evaluation order of binary expressions (PR101640)
    
    The use of fold_build2 can in some cases swap the order of its operands
    if that is the more optimal thing to do.  However this breaks semantic
    guarantee of left-to-right evaluation in D.
    
            PR d/101640
    
    gcc/d/ChangeLog:
    
            * expr.cc (binary_op): Use build2 instead of fold_build2.
    
    gcc/testsuite/ChangeLog:
    
            * gdc.dg/pr96429.d: Update test.
            * gdc.dg/pr101640.d: New test.
    
    (cherry picked from commit 54ec50bada94a8ff92edb04ee5216c27fa4bf942)

diff --git a/gcc/d/expr.cc b/gcc/d/expr.cc
index e76cae98f7e..b78778eb8ef 100644
--- a/gcc/d/expr.cc
+++ b/gcc/d/expr.cc
@@ -157,7 +157,7 @@ binary_op (tree_code code, tree type, tree arg0, tree arg1)
 	  eptype = type;
 	}
 
-      ret = fold_build2 (code, eptype, arg0, arg1);
+      ret = build2 (code, eptype, arg0, arg1);
     }
 
   return d_convert (type, ret);
diff --git a/gcc/testsuite/gdc.dg/pr101640.d b/gcc/testsuite/gdc.dg/pr101640.d
new file mode 100644
index 00000000000..68de4088512
--- /dev/null
+++ b/gcc/testsuite/gdc.dg/pr101640.d
@@ -0,0 +1,11 @@
+// https://gcc.gnu.org/bugzilla/show_bug.cgi?id=101640
+// { dg-do compile }
+// { dg-options "-fdump-tree-original" }
+
+int fun101640(ref int);
+
+int test101640(int val)
+{
+    // { dg-final { scan-tree-dump "= val \\\+ fun101640 \\\(\\\(int &\\\) &val\\\);" "original" } }
+    return val + fun101640(val);
+}
diff --git a/gcc/testsuite/gdc.dg/pr96429.d b/gcc/testsuite/gdc.dg/pr96429.d
index af096e26b5a..9940a03e0ec 100644
--- a/gcc/testsuite/gdc.dg/pr96429.d
+++ b/gcc/testsuite/gdc.dg/pr96429.d
@@ -3,7 +3,7 @@
 // { dg-options "-fdump-tree-original" }
 ptrdiff_t subbyte(byte* bp1, byte* bp2)
 {
-    // { dg-final { scan-tree-dump "bp1 - bp2;" "original" } }
+    // { dg-final { scan-tree-dump "\\\(bp1 - bp2\\\) /\\\[ex\\\] 1;" "original" } }
     return bp1 - bp2;
 }
 

